#include <Python.h>
#include <pygobject.h>
#include <X11/Xlib.h>
#include <X11/Xcursor/Xcursor.h>
#include <gdk/gdkx.h>

/*
     Several caveats are applicable to this:

       - it is a total *HACK*.
       - it is my first python extension module

     Having said that, I wrote it because I found it useful. It's a
     bridge between pygtk and libxcursor.

 */


/*   takes a GdkWindow and a pointer name and sets the xcursor of the
 *   GdkWindow.
 */
void gdk_window_set_xcursor_by_name(GdkWindow* window, gchar *name)
{
     if (window)
     {
          Display *display = GDK_WINDOW_XDISPLAY(window);
          Cursor cursor = XcursorLibraryLoadCursor(display, name);
          XDefineCursor(display, GDK_WINDOW_XID(window), cursor);
     }
}
     

static PyObject *gdkwindow_set_xcursor_by_name(PyObject *self, PyObject *args)
{
     PyGObject *pyWindow = NULL;
     GdkWindow *window = NULL;
     char *cursor;

     if (!PyArg_ParseTuple(args, "Os", &pyWindow, &cursor))
          return NULL;
     window = GDK_WINDOW(pyWindow->obj);
     gdk_window_set_xcursor_by_name(window, cursor);
     Py_INCREF(Py_None);
     return Py_None;
}

static PyMethodDef xcursor_methods[] = {
     {"gdkwindow_set_xcursor", gdkwindow_set_xcursor_by_name, METH_VARARGS, ""},
     {NULL, NULL, 0, NULL}
};

void init_gdk_xcursor()
{
     Display *display;

     Py_InitModule("_gdk_xcursor", xcursor_methods);

     display = XOpenDisplay("");
     if (!display || !XcursorSupportsARGB(display))
          PyErr_SetString(PyExc_ImportError, "haha!");
}
