from distutils.core import setup, Extension
import commands
import os.path

def list_update(dirs, pkg, arg, strip, are_dirs):
    cmd = "pkg-config %s %s" % (arg, pkg)
    items = [i.lstrip(strip)
             for i in commands.getoutput(cmd).split()]
    if are_dirs:
         items = map(os.path.normpath, items)
    for d in items:
        if d not in dirs:
            dirs.append(d)

libs = []
lib_dirs = []
inc_dirs = []
for pkg in ('gtk+-2.0', 'xcursor', 'pygtk-2.0'):
    list_update(inc_dirs, pkg, "--cflags-only-I", "-I", True)
    list_update(lib_dirs, pkg, "--libs-only-L", "-L", True)
    list_update(libs, pkg, "--libs-only-l", "-l", False)
    
xcursor = Extension('_gdk_xcursor',
                    include_dirs = inc_dirs,
                    libraries = libs,
                    library_dirs = lib_dirs,
                    sources = ['_gdk_xcursor.c'])

setup (name = 'gdk-xcursor',
       version = '0.1',
       description = 'A trivial bridge between pygtk and libXcursor',
       author='John Lenton',
       author_email='john@grulic.org.ar',
       url='http://grulic.org.ar/~john/gdk-xcursor/',
       ext_modules = [xcursor],
       py_modules = ["gdk_xcursor"])
